using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using UnityEngine;
using UnityEngine.SceneManagement;
using UnityEngine.UI;

public class GameManager_HUB : MonoBehaviour
{
    private List<IObjetivo> allObjetivos = new List<IObjetivo>();

    private SoundController _soundController;
    
    private IEnumerator Start()
    {
        
        yield return new WaitForSeconds(2);
        _soundController = GetComponent<SoundController>();
        _soundController.playSound(0);

        var objetivos = GameObject.FindGameObjectsWithTag("Objetivo");
        //Lembrar de fazer isso aqui pra todo novo IObjetivo criado
        foreach (var objObjetivo in objetivos)
        {
            allObjetivos.Add(objObjetivo.GetComponent<IObjetivo>());
        }
    }

    private void Update()
    {
        //seria mais performatico notificar esse objeto ao inves de ficart dando pulling.... mas... GO HORSE!!!! GO GGJ!!!
        if (TimerBehavior.timerBehavior.IsTimeOver())
        {
            Lose();
        }
        else
        {
            if (allObjetivos.All(objetivo => objetivo.solucionado))
            {
                Win();
            }
        }
    }

    private void Lose()
    {
        SceneManager.LoadScene("lose");
    }

    private void Win()
    {
        SceneManager.LoadScene("win");
    }
}