﻿using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using UnityEngine;

[RequireComponent (typeof (BoxCollider2D))]
public class WireSlot : MonoBehaviour, IObjetivo {
    public GameObject eletricityParticles;

    private SoundController _soundController;

    private BoxCollider2D boxCollider;
    private Rigidbody2D rigidBody;
    private SpriteRenderer spriteRenderer;

    public EnumSolucaoObjetivo matchSolucaoObjetivo { get; set; }
    public EnumSolucaoObjetivo myObjetivo;

    private GameObject currentObjectColliding;
    
    [TooltipAttribute ("Sprite para mudar o slot para resolvido")]
    public Sprite completedObjective;
    public GameObject caboPendurado;

    [TooltipAttribute ("Quantos do target para dar como resolvido")]
    public int solucaoTargetAmount = 1;

    public int solucaoCurrentAmount { get; set; }

    public bool solucionado { get; set; }

    // Start is called before the first frame update
    void Start ()
    {
        _soundController = GetComponent<SoundController>();
        spriteRenderer = GetComponent<SpriteRenderer> ();
        matchSolucaoObjetivo = myObjetivo;
    }

    // Update is called once per frame
    void Update () {
        UpdateProgress ();
    }

    public bool CheckSolucionado () {
        return solucionado;
    }

    public void UpdateProgress () {

        if (currentObjectColliding == null || solucionado) return;
        ISolucao solucao = currentObjectColliding.GetComponent<ISolucao> ();
        if (solucao == null) return;

        if (matchSolucaoObjetivo == solucao.matchSolucaoObjetivo && !solucao.movedor.isDragging) {
            solucaoCurrentAmount++;
            TriggerEletricityParticles ();
            Destroy (currentObjectColliding);
        }

        if (solucaoCurrentAmount >= solucaoTargetAmount) {
            spriteRenderer.sprite = completedObjective;
            caboPendurado.SetActive(true);
            solucionado = true;
        }
    }

    #region Triggers

    void OnTriggerEnter2D (Collider2D collider) {
        currentObjectColliding = collider.gameObject;
    }

    void OnTriggerExit2D (Collider2D collider) {
        currentObjectColliding = null;
    }

    void TriggerEletricityParticles () {
        _soundController.playSound(0);
        eletricityParticles.SetActive (true);
    }

    #endregion
}