using System;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.Events;

public class SoundController : MonoBehaviour
{
    public AudioClip[] audios;

    private AudioSource getTocador()
    {
        AudioSource retorno = null;

        var sources = gameObject.GetComponents<AudioSource>();

        foreach (var tocador in sources)
        {
            if (tocador != null && !tocador.isPlaying)
            {
                return tocador;
            }
        }

        return gameObject.AddComponent(typeof(AudioSource)).GetComponent<AudioSource>();
    }

    public void playSound(int soundId, float volume = 1, bool loop = false)
    {
        if (soundId >=  audios.Length ) return;
        
        AudioSource tocador = getTocador();
        tocador.volume = volume;
        tocador.loop = loop;
        
        tocador.clip = audios[soundId];
        tocador.Play();
    }
}