using System.Collections;
using UnityEngine;
using UnityEngine.UI;

namespace _Scripts.Common
{
    public class FadeOverlay : MonoBehaviour
    {
        public Color FadeColor = Color.black;

        [SerializeField] private Animator animator = null;
        [SerializeField] private Image colorRect = null;

        private const string FadeOutAnimationState = "FadeOut";
        private const string FadeInAnimationState = "FadeIn";

        private static readonly int fadeOutAnimationHash = Animator.StringToHash(FadeOutAnimationState);
        private static readonly int fadeInAnimationHash = Animator.StringToHash(FadeInAnimationState);

        public IEnumerator FadeOut()
        {
            colorRect.color = FadeColor;
            animator.Play(fadeOutAnimationHash);
            while (animator.GetCurrentAnimatorStateInfo(0).IsName(FadeOutAnimationState))
            {
                yield return null;
            }
        }

        public IEnumerator FadeIn()
        {
            animator.Play(fadeInAnimationHash);
            while (animator.GetCurrentAnimatorStateInfo(0).IsName(FadeInAnimationState))
            {
                yield return null;
            }
        }

    }
}
